OGRE-Next: Ogre::DefaultSceneManager Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::DefaultSceneManager Class Referencefinal
Core | Component » Scene

Default scene manager. More...

`#include <OgreSceneManagerEnumerator.h>`

Inheritance diagram for Ogre::DefaultSceneManager:
[legend]

## Public Member Functions
| DefaultSceneManager (const String &name, size_t numWorkerThreads)
| ~DefaultSceneManager () override
const String & | getTypeName () const override
| Retrieve the type name of this scene manager.
Public Member Functions inherited from Ogre::SceneManager
| SceneManager (const String &instanceName, size_t numWorkerThreads)
| Constructor.
virtual | ~SceneManager ()
| Default destructor.
virtual void | _addAutotrackingSceneNode (SceneNode *source, SceneNode *target, const Vector3 &offset, const Vector3 &localDirection)
| Internal method for notifying the manager that a SceneNode is autotracking.
void | _addCompositorTexture (IdString name, TextureGpu *tex)
| Used by Compositor, tells of which compositor textures active, so Materials can access them.
void | _addWireAabb (WireAabb *wireAabb)
virtual void | _applySceneAnimations ()
| Internal method for applying animations to scene nodes.
virtual bool | _areRenderStateChangesSuppressed () const
| Are render state changes suppressed?
AxisAlignedBox | _calculateCurrentCastersBox (uint32 viewportVisibilityMask, uint8 firstRq, uint8 lastRq) const
bool | _collectForwardPlusObjects (const Camera *camera)
| Returns true if collection code was run.
virtual InternalCubemapProbe * | _createCubemapProbe (SceneMemoryMgrTypes sceneType)
virtual SceneNode * | _createSceneNode (SceneNode *parent, NodeMemoryManager *nodeMemoryManager)
virtual TagPoint * | _createTagPoint (SceneNode *parent, NodeMemoryManager *nodeMemoryManager)
| Don't call this function directly.
virtual void | _cullPhase01 (Camera *cullCamera, Camera *renderCamera, const Camera *lodCamera, uint8 firstRq, uint8 lastRq, bool reuseCullData)
| Performs the frustum culling that will later be needed by _renderPhase02.
virtual void | _destroyAllCubemapProbes ()
virtual void | _destroyCubemapProbe (InternalCubemapProbe *probe)
void | _frameEnded ()
| Called when the frame has fully ended (ALL passes have been executed to all RTTs).
ForwardPlusBase * | _getActivePassForwardPlus ()
AutoParamDataSource * | _getAutoParamDataSource () const
uint32 | _getCombinedVisibilityMask () const
| Internal method for getting the combination between the global visibility mask and the per-viewport visibility mask.
IlluminationRenderStage | _getCurrentRenderStage () const
ObjectMemoryManager & | _getEntityMemoryManager (SceneMemoryMgrTypes sceneType)
| Retrieves the main entity memory manager.
ObjectMemoryManager & | _getLightMemoryManager ()
NodeMemoryManager & | _getNodeMemoryManager (SceneMemoryMgrTypes sceneType)
NodeMemoryManager & | _getTagPointNodeMemoryManager ()
VisibleObjectsPerThreadArray & | _getTmpVisibleObjectsList ()
void | _handleLodEvents ()
| Handle LOD events.
virtual void | _markGpuParamsDirty (uint16 mask)
| Method to allow you to mark gpu parameters as dirty, causing them to be updated according to the mask that you set when updateGpuProgramParameters is next called.
void | _notifyEntityMaterialLodChanged (EntityMaterialLodChangedEvent &evt)
| Notify that an entity material LOD change event has occurred.
void | _notifyEntityMeshLodChanged (EntityMeshLodChangedEvent &evt)
| Notify that an entity mesh LOD change event has occurred.
void | _notifyMovableObjectLodChanged (MovableObjectLodChangedEvent &evt)
| Notify that a movable object LOD change event has occurred.
virtual RenderContext * | _pauseRendering ()
| Pause rendering of the frame.
virtual void | _releaseManualHardwareResources ()
| Notifies the scene manager that hardware resources were lost.
virtual void | _removeAutotrackingSceneNode (SceneNode *source)
void | _removeCompositorTextures (size_t from)
| Removes all compositor textures from 'from' to end.
void | _removeSkeletonDef (const SkeletonDef *skeletonDef)
| Removes a skeleton definition from its memory manager.
void | _removeWireAabb (WireAabb *wireAabb)
virtual void | _renderPhase02 (Camera *camera, const Camera *lodCamera, uint8 firstRq, uint8 lastRq, bool includeOverlays)
| Prompts the class to send its contents to the renderer.
virtual void | _renderSingleObject (Renderable *pRend, const MovableObject *pMovableObject, bool casterPass, bool dualParaboloid)
virtual void | _restoreManualHardwareResources ()
| Notifies the scene manager that hardware resources should be restored.
virtual void | _resumeRendering (RenderContext *context)
| Resume rendering of the frame.
void | _setAtmosphere (AtmosphereComponent *atmosphere)
| Sets an external atmosphere provider.
void | _setCamerasInProgress (const CamerasInProgress &cameras)
void | _setCurrentCompositorPass (CompositorPass *pass)
void | _setCurrentRenderStage (IlluminationRenderStage stage)
void | _setCurrentShadowNode (CompositorShadowNode *shadowNode)
virtual void | _setDestinationRenderSystem (RenderSystem *sys)
| Notifies the scene manager of its destination render system.
void | _setForwardPlusEnabledInPass (bool bEnable)
| For internal use.
void | _setLightCullingVisibility (Camera *camera, bool collectLights, bool isCubemap)
| See Camera::setLightCullingVisibility.
void | _setPrePassMode (PrePassMode mode, const TextureGpuVec &prepassTextures, TextureGpu *prepassDepthTexture, TextureGpu *ssrTexture)
| For internal use.
void | _setRefractions (TextureGpu *depthTextureNoMsaa, TextureGpu *refractionsTexture)
virtual void | _suppressRenderStateChanges (bool suppress)
| Indicates to the SceneManager whether it should suppress changing the RenderSystem states when rendering objects.
unsigned long | _updateWorkerThread (ThreadHandle *threadHandle)
| Called from the worker thread, polls to process frustum culling requests when a sync is performed.
void | _warmUpShaders (Camera *camera, uint32_t visibilityMask, uint8 firstRq, uint8 lastRq)
virtual void | addListener (Listener *s)
| Add a listener which will get called back on scene manager events.
void | addLodListener (LodListener *listener)
| Add a level of detail listener.
virtual void | addRenderObjectListener (RenderObjectListener *newListener)
| Registers a new Render Object Listener which will be notified when rendering an object.
virtual void | addRenderQueueListener (RenderQueueListener *newListener)
| Registers a new RenderQueueListener which will be notified when render queues are processed.
void | clearFrameData ()
| Clears temporary buffers and other data that needs to live every frame.
virtual void | clearScene (bool deleteIndestructibleToo, bool reattachCameras=true)
| Empties the entire scene, inluding all SceneNodes, Entities, Lights, BillboardSets etc.
virtual AxisAlignedBoxSceneQuery * | createAABBQuery (const AxisAlignedBox &box, uint32 mask=QUERY_ENTITY_DEFAULT_MASK)
| Creates an AxisAlignedBoxSceneQuery for this scene manager.
virtual v1::Animation * | createAnimation (const String &name, Real length)
| Creates an animation which can be used to animate scene nodes.
virtual v1::AnimationState * | createAnimationState (const String &animName)
| Create an AnimationState object for managing application of animations.
virtual v1::BillboardChain * | createBillboardChain ()
| Create a BillboardChain, an object which you can use to render a linked chain of billboards.
virtual v1::BillboardSet * | createBillboardSet (unsigned int poolSize=20, SceneMemoryMgrTypes sceneType=SCENE_DYNAMIC)
| Creates a new BillboardSet for use with this scene manager.
virtual Camera * | createCamera (const String &name, bool notShadowCaster=true, bool forCubemapping=false)
| Creates a camera to be managed by this scene manager.
virtual Decal * | createDecal (SceneMemoryMgrTypes sceneType=SCENE_DYNAMIC)
virtual v1::Entity * | createEntity (const String &meshName, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME, SceneMemoryMgrTypes sceneType=SCENE_DYNAMIC)
| Create an Entity (instance of a discrete mesh).
virtual v1::Entity * | createEntity (const v1::MeshPtr &pMesh, SceneMemoryMgrTypes sceneType=SCENE_DYNAMIC)
| Create an Entity (instance of a discrete mesh).
virtual v1::Entity * | createEntity (PrefabType ptype, SceneMemoryMgrTypes sceneType=SCENE_DYNAMIC)
| Create an Entity (instance of a discrete mesh) from a range of prefab shapes.
virtual IntersectionSceneQuery * | createIntersectionQuery (uint32 mask=QUERY_ENTITY_DEFAULT_MASK)
| Creates an IntersectionSceneQuery for this scene manager.
virtual Item * | createItem (const MeshPtr &pMesh, SceneMemoryMgrTypes sceneType=SCENE_DYNAMIC)
| Create an Item (instance of a discrete mesh).
virtual Item * | createItem (const String &meshName, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME, SceneMemoryMgrTypes sceneType=SCENE_DYNAMIC, bool bUseMeshMat=true)
| Create an Item (instance of a discrete mesh).
virtual Light * | createLight ()
| Creates a light for use in the scene.
virtual ManualObject * | createManualObject (SceneMemoryMgrTypes sceneType=SCENE_DYNAMIC)
| Create a ManualObject, an object which you populate with geometry manually through a GL immediate-mode style interface.
virtual MovableObject * | createMovableObject (const String &typeName, ObjectMemoryManager *objectMemMgr, const NameValuePairList *params=0)
| Create a movable object of the type specified without a name.
virtual ParticleSystem * | createParticleSystem (const String &templateName)
| Creates a particle system based on a template.
virtual ParticleSystem * | createParticleSystem (size_t quota=500, const String &resourceGroup=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME)
| Create a blank particle system.
virtual PlaneBoundedVolumeListSceneQuery * | createPlaneBoundedVolumeQuery (const PlaneBoundedVolumeList &volumes, uint32 mask=QUERY_ENTITY_DEFAULT_MASK)
| Creates a PlaneBoundedVolumeListSceneQuery for this scene manager.
virtual RaySceneQuery * | createRayQuery (const Ray &ray, uint32 mask=QUERY_ENTITY_DEFAULT_MASK)
| Creates a RaySceneQuery for this scene manager.
virtual Rectangle2D * | createRectangle2D (SceneMemoryMgrTypes sceneType=SCENE_STATIC)
| Creates a 2D rectangle that can be displayed for screen space effects or showing a basic GUI.
virtual v1::RibbonTrail * | createRibbonTrail ()
| Create a RibbonTrail, an object which you can use to render a linked chain of billboards which follows one or more nodes.
virtual SceneNode * | createSceneNode (SceneMemoryMgrTypes sceneType=SCENE_DYNAMIC)
| Creates an instance of a SceneNode.
SkeletonInstance * | createSkeletonInstance (const SkeletonDef *skeletonDef)
| Creates an instance of a skeleton based on the given definition.
virtual SphereSceneQuery * | createSphereQuery (const Sphere &sphere, uint32 mask=QUERY_ENTITY_DEFAULT_MASK)
| Creates a SphereSceneQuery for this scene manager.
virtual TagPoint * | createTagPoint ()
| Creates a TagPoint that can be used like a SceneNode, or be used to be attached to a Bone.
virtual WireAabb * | createWireAabb ()
| Create an WireAabb.
void | cullLights (Camera *camera, Light::LightTypes startType, Light::LightTypes endType, LightArray &outLights)
void | defragmentMemoryPools ()
| Triggers on demand a defragmentation of the pools, so that all slots become contiguous in memory.
virtual void | destroyAllAnimations ()
| Removes all animations created using this SceneManager.
virtual void | destroyAllAnimationStates ()
| Removes all animation states created using this SceneManager.
virtual void | destroyAllBillboardChains ()
| Removes & destroys all BillboardChains from the SceneManager.
virtual void | destroyAllBillboardSets ()
| Removes & destroys all BillboardSets.
virtual void | destroyAllCameras ()
| Removes (and destroys) all cameras from the scene.
virtual void | destroyAllDecals ()
virtual void | destroyAllEntities ()
| Removes & destroys all Entities.
virtual void | destroyAllItems ()
| Removes & destroys all Items.
virtual void | destroyAllLights ()
| Removes and destroys all lights in the scene.
virtual void | destroyAllManualObjects ()
| Removes & destroys all ManualObjects from the SceneManager.
virtual void | destroyAllMovableObjects ()
| Destroy all MovableObjects.
virtual void | destroyAllMovableObjectsByType (const String &typeName)
| Destroy all MovableObjects of a given type.
virtual void | destroyAllParticleSystems ()
| Removes & destroys all ParticleSystems from the SceneManager.
virtual void | destroyAllRectangle2D ()
| Removes & destroys all Rectangle2D.
virtual void | destroyAllRibbonTrails ()
| Removes & destroys all RibbonTrails from the SceneManager.
virtual void | destroyAllWireAabbs ()
| Removes & destroys all WireAabbs.
virtual void | destroyAnimation (const String &name)
| Destroys an Animation.
virtual void | destroyAnimationState (const String &name)
| Destroys an AnimationState.
virtual void | destroyBillboardChain (v1::BillboardChain *obj)
| Removes & destroys a BillboardChain from the SceneManager.
virtual void | destroyBillboardSet (v1::BillboardSet *set)
| Removes & destroys an BillboardSet from the SceneManager.
virtual void | destroyCamera (Camera *cam)
| Removes a camera from the scene.
virtual void | destroyDecal (Decal *decal)
virtual void | destroyEntity (v1::Entity *ent)
| Removes & destroys an Entity from the SceneManager.
virtual void | destroyItem (Item *item)
| Removes & destroys an Item from the SceneManager.
virtual void | destroyLight (Light *light)
| Removes the light from the scene and destroys it based on a pointer.
virtual void | destroyManualObject (ManualObject *obj)
| Removes & destroys a ManualObject from the SceneManager.
virtual void | destroyMovableObject (MovableObject *m)
| Destroys a MovableObject.
virtual void | destroyMovableObject (MovableObject *m, const String &typeName)
| Destroys a MovableObject with the name specified, of the type specified.
virtual void | destroyParticleSystem (ParticleSystem *obj)
| Removes & destroys a ParticleSystem from the SceneManager.
virtual void | destroyQuery (SceneQuery *query)
| Destroys a scene query of any type.
virtual void | destroyRectangle2D (Rectangle2D *rect)
| Removes & destroys an Entity from the SceneManager.
virtual void | destroyRibbonTrail (v1::RibbonTrail *obj)
| Removes & destroys a RibbonTrail from the SceneManager.
virtual void | destroySceneNode (SceneNode *sn)
| Destroys a SceneNode.
void | destroySkeletonInstance (SkeletonInstance *skeletonInstance)
| Destroys an instance of a skeleton created with createSkeletonInstance().
virtual void | destroyWireAabb (WireAabb *wireAabb)
| Removes & destroys an WireAabb from the SceneManager.
void | executeUserScalableTask (UniformScalableTask *task, bool bBlock)
| Processes a user-defined UniformScalableTask in the worker threads spawned by SceneManager.
virtual void | extractAllMovableObjectsByType (const String &typeName)
| Extract all injected MovableObjects of a given type.
virtual void | extractMovableObject (MovableObject *m)
| Extract a previously injected MovableObject.
virtual Camera * | findCamera (IdString name) const
| Finds the camera with the given name.
virtual Camera * | findCameraNoThrow (IdString name) const
| Finds the camera with the given name.
virtual MovableObjectVec | findMovableObjects (const String &type, const String &name)
| Finds all the movable objects with the type and name passed as parameters.
virtual_l1 SceneNodeList | findSceneNodes (const String &name) const
| Finds all the scene nodes with the name passed as parameter.
const Vector3 & | getAmbientLightHemisphereDir () const
const ColourValue & | getAmbientLightLowerHemisphere () const
const ColourValue & | getAmbientLightUpperHemisphere () const
| Returns the ambient light level to be used for the scene.
virtual v1::Animation * | getAnimation (const String &name) const
| Looks up an Animation object previously created with createAnimation.
AnimationIterator | getAnimationIterator ()
| Returns a specialised MapIterator over all animations in the scene.
const AnimationList & | getAnimations () const
| Returns a const version of the animation list.
virtual v1::AnimationState * | getAnimationState (const String &animName) const
| Retrieves animation state as previously created using createAnimationState.
v1::AnimationStateIterator | getAnimationStateIterator ()
| Returns a specialised MapIterator over all animation states in the scene.
AtmosphereComponent * | getAtmosphere ()
| Gets currently set atmosphere. It's never nullptr.
AtmosphereComponent * | getAtmosphereRaw ()
| Gets currently set atmosphere. Can be nullptr if none is set.
CameraIterator | getCameraIterator ()
| Returns a specialised MapIterator over all cameras in the scene.
const CameraList & | getCameras () const
| Returns a const version of the camera list.
CamerasInProgress | getCamerasInProgress () const
| Gets the current camera being rendered (advanced use only, only valid during viewport update.
const CompositorTextureVec & | getCompositorTextures () const
const AxisAlignedBox & | getCurrentCastersBox () const
const CompositorPass * | getCurrentCompositorPass () const
| Note: May be null.
TextureGpu * | getCurrentPassDepthTextureNoMsaa () const
TextureGpu * | getCurrentPrePassDepthTexture () const
PrePassMode | getCurrentPrePassMode () const
const TextureGpuVec & | getCurrentPrePassTextures () const
TextureGpu * | getCurrentRefractionsTexture () const
const CompositorShadowNode * | getCurrentShadowNode () const
TextureGpu * | getCurrentSsrTexture () const
Viewport * | getCurrentViewport0 () const
| Gets the current viewport being rendered (advanced use only, only valid during viewport update.
TextureGpu * | getDecalsDiffuse () const
TextureGpu * | getDecalsEmissive () const
TextureGpu * | getDecalsNormals () const
RenderSystem * | getDestinationRenderSystem ()
| Get the rendersystem subclass to which the output of this Scene Manager gets sent.
virtual bool | getDisplaySceneNodes () const
| Returns true if all scene nodes axis are to be displayed.
SceneNode * | getDummySceneNode () const
| Unlike mNodeMemoryManager->_getDummyNode(), this dummy node is fully allocated, which makes it possible to actually attach objects to this dummy, while we guarantee the dummy won't change its transform.
uint32 | getEnvFeatures () const
virtual bool | getFindVisibleObjects ()
| Gets whether the SceneManager should search for visible objects, or whether they are being manually handled.
virtual bool | getFlipCullingOnNegativeScale () const
| Get whether to automatically flip the culling mode on objects whenever they are negatively scaled.
ForwardPlusBase * | getForwardPlus ()
const LightListInfo & | getGlobalLightList () const
virtual const PlaneList & | getLightClippingPlanes (const Light *l)
| Retrieve a set of clipping planes for a given light.
virtual_l2 uint32 | getLightMask () const
| Gets a mask which is bitwise 'and'ed with lights' own light masks to determine if the light should be casting light.
virtual const RealRect & | getLightScissorRect (const Light *l, const Camera *cam)
| Retrieve a scissor rectangle for a given light and camera.
void | getMinMaxDepthRange (const Frustum *shadowMapCamera, Real &outMin, Real &outMax) const
virtual MovableObjectIterator | getMovableObjectIterator (const String &typeName)
| Get an iterator over all MovableObect instances of a given type.
const String & | getName () const
| Return the instance name of this SceneManager.
size_t | getNumCompositorTextures () const
| Gets the number of currently active compositor textures.
size_t | getNumWorkerThreads () const
virtual bool | getOption (const String &strKey, void *pDestValue)
| Method for getting the value of an implementation-specific Scene Manager option.
virtual bool | getOptionKeys (StringVector &refKeys)
| Method for getting all the implementation-specific options of the scene manager.
virtual bool | getOptionValues (const String &strKey, StringVector &refValueList)
| Method for getting all possible values for a specific option.
RadialDensityMask * | getRadialDensityMask () const
Vector3 | getRelativeOrigin () const
| Returns the current relative origin. (Only when non-permanent).
RenderQueue * | getRenderQueue () const
| Returns the RenderQueue.
SceneNode * | getRootSceneNode (SceneMemoryMgrTypes sceneType=SCENE_DYNAMIC)
| Gets the SceneNode at the root of the scene hierarchy.
virtual_l1 SceneNode * | getSceneNode (IdType id)
| Retrieves a SceneNode based on it's ID from the scene graph.
virtual_l1 const SceneNode * | getSceneNode (IdType id) const
virtual const ColourValue & | getShadowColour () const
| Get the colour used to modulate areas in shadow.
virtual Real | getShadowDirectionalLightExtrusionDistance () const
| Gets the distance a shadow volume is extruded for a directional light.
virtual Real | getShadowDirLightTextureOffset () const
| Gets the proportional distance which a texture shadow which is generated from a directional light will be offset into the camera view to make best use of texture space.
virtual Real | getShadowFarDistance () const
| Gets the default maximum distance away from the camera that shadows will be visible.
virtual Real | getShadowFarDistanceSquared () const
virtual bool | getShowBoundingBoxes () const
| Returns if all bounding boxes of scene nodes are to be displayed.
Rectangle2D * | getSky ()
MaterialPtr | getSkyMaterial ()
SkyMethod | getSkyMethod () const
const float * | getSphericalHarmonics () const
virtual ViewPoint | getSuggestedViewpoint (bool random=false)
| Asks the SceneManager to provide a suggested viewpoint from which the scene should be viewed.
virtual_l2 uint32 | getVisibilityMask () const
| Gets a mask which is bitwise 'and'ed with objects own visibility masks to determine if the object is visible.
virtual bool | hasAnimation (const String &name) const
| Returns whether an animation with the given name exists.
virtual bool | hasAnimationState (const String &name) const
| Returns whether an animation state with the given name exists.
virtual bool | hasMovableObject (MovableObject *m)
| Returns if this SceneManager contains the specified MovableObject.
virtual bool | hasOption (const String &strKey) const
| Method for verifying whether the scene manager has an implementation-specific option.
virtual void | injectMovableObject (MovableObject *m)
| Inject a MovableObject instance created externally.
bool | isDecalsDiffuseEmissiveMerged () const
bool | isSkyEnabled () const
bool | isUsingInstancedStereo () const
void | notifyStaticAabbDirty (MovableObject *movableObject)
| Notifies that the given MovableObject is dirty (i.e.
void | notifyStaticDirty (Node *node)
| Notifies that the given Node is dirty (i.e.
| OGRE_DEPRECATED_VER (3) virtual const ColourValue &getFogColour() const
| Returns the fog colour for the scene.
| OGRE_DEPRECATED_VER (3) virtual FogMode getFogMode() const
| Returns the fog mode for the scene.
| OGRE_DEPRECATED_VER (3) virtual Real getFogDensity() const
| Returns the fog density for the scene.
| OGRE_DEPRECATED_VER (3) virtual Real getFogEnd() const
| Returns the fog end distance for the scene.
| OGRE_DEPRECATED_VER (3) virtual Real getFogStart() const
| Returns the fog start distance for the scene.
| OGRE_MUTEX (sceneGraphMutex)
| Mutex to protect the scene graph from simultaneous access from multiple threads.
virtual void | registerSceneNodeListener (SceneNode *sceneNode)
| Node listeners need to be registered with us so that they can be successfully called when calling updateAllTransforms.
virtual void | removeListener (Listener *s)
| Remove a listener.
void | removeLodListener (LodListener *listener)
| Remove a level of detail listener.
virtual void | removeRenderObjectListener (RenderObjectListener *delListener)
| Removes a listener previously added with addRenderObjectListener.
virtual void | removeRenderQueueListener (RenderQueueListener *delListener)
| Removes a listener previously added with addRenderQueueListener.
void | reserveSlotsInGlobalLightList (size_t addSlotsToCapacity=0)
| Allocates required memory in mGlobalLightList.
void | setAmbientLight (const ColourValue &upperHemisphere, const ColourValue &lowerHemisphere, const Vector3 &hemisphereDir, Real envmapScale=1.0f, uint32 envFeatures=0xffffffff)
| Sets the ambient light level to be used for the scene.
void | setBuildLegacyLightList (bool bEnable)
| Enables or disables the legace 1.9 way of building light lists which can be used by HlmsLowLevel materials.
void | setDecalsDiffuse (TextureGpu *tex)
| Sets the decal texture for diffuse.
void | setDecalsEmissive (TextureGpu *tex)
| See SceneManager::setDecalsDiffuse.
void | setDecalsNormals (TextureGpu *tex)
| Sets the decal texture normal maps.
virtual void | setDisplaySceneNodes (bool display)
| Tells the SceneManager whether it should render the SceneNodes which make up the scene as well as the objects in the scene.
virtual void | setFindVisibleObjects (bool find)
| Sets whether the SceneManager should search for visible objects, or whether they are being manually handled.
virtual void | setFlipCullingOnNegativeScale (bool n)
| Set whether to automatically flip the culling mode on objects whenever they are negatively scaled.
void | setFog (FogMode mode=FOG_NONE, const ColourValue &colour=ColourValue::White, Real expDensity=Real(0.001), Real linearStart=Real(0.0), Real linearEnd=Real(1.0))
| Sets the fogging mode applied to the scene.
void | setForward3D (bool bEnable, uint32 width, uint32 height, uint32 numSlices, uint32 lightsPerCell, float minDistance, float maxDistance)
| Enables or disables the Forward3D implementation for using many non-shadowed lights in the scene.
void | setForwardClustered (bool bEnable, uint32 width, uint32 height, uint32 numSlices, uint32 lightsPerCell, uint32 decalsPerCell, uint32 cubemapProbesPerCel, float minDistance, float maxDistance)
virtual_l2 void | setLightMask (uint32 mask)
| Sets a mask which is bitwise 'and'ed with lights' own light masks to determine if the light should be casting light.
virtual bool | setOption (const String &strKey, const void *pValue)
| Method for setting a specific option of the Scene Manager.
void | setRadialDensityMask (bool bEnabled, const float radius[3])
| Draws a Radial Density Mask to lower the quality around the edges in VR.
virtual void | setRelativeOrigin (const Vector3 &relativeOrigin, bool bPermanent)
| Set whether to use relative offset co-ordinates when rendering, ie offset to subtract to the camera, lights & objects.
virtual void | setShadowColour (const ColourValue &colour)
| Set the colour used to modulate areas in shadow.
virtual void | setShadowDirectionalLightExtrusionDistance (Real dist)
| Sets the distance a shadow volume is extruded for a directional light.
virtual void | setShadowDirLightTextureOffset (Real offset)
| Sets the proportional distance which a texture shadow which is generated from a directional light will be offset into the camera view to make best use of texture space.
virtual void | setShadowFarDistance (Real distance)
| Sets the default maximum distance away from the camera that shadows will be visible.
virtual void | setShadowTextureFadeEnd (Real fadeEnd)
| Sets the proportional distance at which texture shadows finish to fading out.
virtual void | setShadowTextureFadeStart (Real fadeStart)
| Sets the proportional distance at which texture shadows begin to fade out.
void | setSky (bool bEnabled, SkyMethod skyMethod, const String &texName, const String &resourceGroup)
void | setSky (bool bEnabled, SkyMethod skyMethod, TextureGpu *texture)
| Sets a sky, to use a particular material based on SkyMethod.
void | setSphericalHarmonics (Vector3 ambientSphericalHarmonics[9])
virtual_l2 void | setVisibilityMask (uint32 vmask)
| Sets a mask which is bitwise 'and'ed with objects own visibility masks to determine if the object is visible.
virtual void | showBoundingBoxes (bool bShow)
| Allows all bounding boxes of scene nodes to be displayed.
void | shrinkToFitMemoryPools ()
| Defragments memory, then reallocates a smaller pool that tightly fits the current number of objects.
virtual void | unregisterSceneNodeListener (SceneNode *sceneNode)
| Unregisters a registered node for listening.
void | updateAllAnimations ()
| Updates all skeletal animations in the scene.
void | updateAllBounds (const ObjectMemoryManagerVec &objectMemManager)
| Updates the world aabbs from all entities in the scene.
void | updateAllLods (const Camera *lodCamera, Real lodBias, uint8 firstRq, uint8 lastRq)
| Updates the Lod values of all objects relative to the given camera.
void | updateAllTagPoints ()
| Updates all TagPoints, both TagPoints that are children of bones, and TagPoints that are children of other TagPoints.
void | updateAllTransforms ()
| Updates the derived transforms of all nodes in the scene.
void | updateSceneGraph ()
| Updates the scene: Perform high level culling, Node transforms and entity animations.
void | waitForPendingUserScalableTask ()
| Blocks until the the task from processUserScalableTask finishes.
Public Member Functions inherited from Ogre::IdObject
| IdObject (IdType id)
| We don't call generateNewId() here, to prevent objects in the stack (i.e.
IdType | getId () const
| Get the unique id of this object.
bool | operator() (const IdObject &left, const IdObject &right)
bool | operator() (const IdObject *left, const IdObject *right)

## Additional Inherited Members
Public Types inherited from Ogre::SceneManager
typedef MapIterator< AnimationList > | AnimationIterator
typedef VectorIterator< CameraList > | CameraIterator
enum | EnvFeatures { EnvFeatures_DiffuseGiFromReflectionProbe = 1u << 0u }
enum | IlluminationRenderStage { IRS_NONE , IRS_RENDER_TO_TEXTURE }
| Describes the stage of rendering when performing complex illumination. More...
typedef VectorIterator< MovableObjectVec > | MovableObjectIterator
typedef vector< MovableObject * >::type | MovableObjectVec
enum | PrefabType { PT_PLANE , PT_CUBE , PT_SPHERE }
| Prefab shapes available without loading a model. More...
typedef vector< SceneNode * >::type | SceneNodeList
enum | SkyMethod { SkyCubemap , SkyEquirectangular }
Static Public Attributes inherited from Ogre::SceneManager
static uint32 | QUERY_ENTITY_DEFAULT_MASK
| Default query mask for entities.
static uint32 | QUERY_FRUSTUM_DEFAULT_MASK
| Default query mask for frusta and cameras.
static uint32 | QUERY_FX_DEFAULT_MASK
| Default query mask for effects like billboardsets / particle systems.
static uint32 | QUERY_LIGHT_DEFAULT_MASK
| Default query mask for lights.
static uint32 | QUERY_STATICGEOMETRY_DEFAULT_MASK
| Default query mask for StaticGeometry.

## Detailed Description

Default scene manager.

## Constructor & Destructor Documentation

## ◆ DefaultSceneManager()

Ogre::DefaultSceneManager::DefaultSceneManager | ( | const String & | name,
|  | size_t | numWorkerThreads )

## ◆ ~DefaultSceneManager()

Ogre::DefaultSceneManager::~DefaultSceneManager | ( |  | ) |
| override

## Member Function Documentation

## ◆ getTypeName()

const String & Ogre::DefaultSceneManager::getTypeName | ( |  | ) | const
| overridevirtual

Retrieve the type name of this scene manager.

Remarks
  This method has to be implemented by subclasses. It should return the type name of this SceneManager which agrees with the type name of the SceneManagerFactory which created it.

Implements Ogre::SceneManager.

The documentation for this class was generated from the following file:

- OgreSceneManagerEnumerator.h